
#importerer nødvendige pakker

import tensorflow as tf
from tensorflow import keras
from tensorflow.keras import layers
from keras.models import Sequential
from keras.layers import Activation, Dense, Flatten, BatchNormalization, Conv2D, MaxPooling2D, Dropout
from keras.metrics import categorical_crossentropy
from keras_preprocessing.image import ImageDataGenerator
from keras.applications.vgg16 import preprocess_input
from tensorflow.keras.optimizers import Adam
from sklearn.metrics import confusion_matrix
import itertools
import os


import matplotlib.pyplot as plt
import os
import numpy as np
import PIL
from numpy import asarray



train_path = (sti_til_trensett)
test_path = (sti_til_testsett)


train_batches = ImageDataGenerator(preprocessing_function=tf.keras.applications.vgg16.preprocess_input) \
    .flow_from_directory(directory=train_path, target_size=(1536, 1536),
                         classes=['0.0', '0.5', '1.0', '1.5', '2.0', '2.5', '3.0'], batch_size=5, shuffle=True)

test_batches = ImageDataGenerator(preprocessing_function=tf.keras.applications.vgg16.preprocess_input) \
    .flow_from_directory(directory=test_path, target_size=(1536, 1536),
                         classes=['0.0', '0.5', '1.0', '1.5', '2.0', '2.5', '3.0'], batch_size=5, shuffle=True)








model = Sequential()

#blokk 1 - entry blokk
model.add(Conv2D(input_shape=(1536,1536,3),filters=(64),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(64),kernel_size=(3,3),padding="valid",strides=(2,2)))
model.add(BatchNormalization())
model.add(Activation("relu"))
model.add(MaxPooling2D(pool_size=(3,3),strides=(3,3)))



#blokk 2
model.add(Conv2D(filters=(128),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(128),kernel_size=(3,3),padding="same"))
model.add(BatchNormalization())
model.add(Activation("relu"))
model.add(MaxPooling2D(pool_size=(3,3),strides=(2,2)))

#blokk 3
model.add(Conv2D(filters=(256),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(256),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(256),kernel_size=(3,3),padding="same"))
model.add(BatchNormalization())
model.add(Activation("relu"))
model.add(MaxPooling2D(pool_size=(3,3),strides=(2,2)))


#blokk 4
model.add(Conv2D(filters=(512),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(512),kernel_size=(3,3),padding="same"))
model.add(BatchNormalization())
model.add(Activation("relu"))
model.add(Conv2D(filters=(512),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(512),kernel_size=(3,3),padding="same"))
model.add(BatchNormalization())
model.add(Activation("relu"))
model.add(MaxPooling2D(pool_size=(2,2),strides=(2,2)))


#blokk 5
model.add(Conv2D(filters=(728),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(728),kernel_size=(3,3),padding="same"))
model.add(BatchNormalization())
model.add(Activation("relu"))
model.add(Conv2D(filters=(728),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(728),kernel_size=(3,3),padding="same"))
model.add(Activation("relu"))
model.add(Conv2D(filters=(728),kernel_size=(3,3),padding="same"))
model.add(BatchNormalization())
model.add(Activation("relu"))
model.add(MaxPooling2D(pool_size=(2,2),strides=(2,2)))



#klassifiserings blokk
model.add(Flatten())
model.add(Dense(units=4096))
model.add(Activation("relu"))
model.add(Dropout(0.5))
model.add(Dense(units=4096))
model.add(Activation("relu"))
model.add(Dense(units=7))
model.add(Activation("softmax"))


model.summary()


epochs=50
batch_size=5
callbacks = [keras.callbacks.ModelCheckpoint("save_at_{epoch}.h5", save_best_only=True, save_weights_only=False)]
model.compile(optimizer=keras.optimizers.Adam(learning_rate=1e-5),loss="categorical_crossentropy",metrics=["accuracy"])



model.fit(x=train_batches,
    steps_per_epoch=train_batches.samples // batch_size,
    epochs=epochs,
    validation_data=test_batches,
    validation_steps=test_batches.samples // batch_size,
    verbose=True)

