from pathlib import Path
import pandas as pd
from shutil import copyfile


def get_df(navn=sti_til_csv_fil):
    return pd.read_csv(navn)


df = get_df()


def finn_atrium(filsti=sti_til_mappe):
    navn = Path(filsti).stem
    nummer = str(navn)[:6]
    atrium = df.loc[df.Bildefil == nummer, 'atrium_new']
    try:
        atrium = float(atrium)
    except:
        atrium = 9.9
    return atrium


def navn_med_atrium(filsti, artium):
    navn = Path(filsti).stem
    utnavn = f'{artium:3.1f}_{navn[:6]}.png'
    return utnavn


def kopier_fil(innfil=sti_til_mappe_inn, utmappe=sti_til_mappe_ut):
    atrium = finn_atrium(innfil)
    navn = navn_med_atrium(innfil, atrium)
    utfil = Path(utmappe) / navn

    innfil = Path(innfil).resolve()
    utfil = Path(utfil).resolve()
    copyfile(innfil, utfil)


if __name__ == '__main__':

    print('Hellow!')
    mappeinn = sti_til_mappe_inn
    mappeut = sti_til_mappe_ut

    innfiler = list(Path(mappeinn).glob('*.png'))
    print(f'fant {len(innfiler)} filer!')
    for fil in innfiler:
        kopier_fil(fil, mappeut)
        print(f'Kopierte {fil}')